"use strict";
{
    C3.Plugins.Mikal_FaceAPI.Acts = {
        async InitializeModels()
        {
            // implementation
            // var modelPath = './'
            var modelPath = ''
            console.log("*** INFO *** Init models with path: " + modelPath)
            try
            {
                await faceapi.loadSsdMobilenetv1Model(modelPath)
                console.log("*** INFO *** loadSsdMobilenetv1Model complete.")
                await faceapi.loadTinyFaceDetectorModel(modelPath)
                console.log("*** INFO *** loadTinyFaceDetectorModel complete.")
                await faceapi.loadFaceLandmarkModel(modelPath)
                console.log("*** INFO *** loadFaceLandmarkModel complete.")
                await faceapi.loadFaceLandmarkTinyModel(modelPath)
                console.log("*** INFO *** loadFaceLandmarkTinyModel complete.")
            }
            catch (err)
            {
                console.log(err)
                alert(err)
            }
        },

        async FaceDetectSingle(uri)
        {
            // input = document.querySelector('canvas')
            let img = await faceapi.fetchImage(uri);
            const detection = await faceapi.detectSingleFace(img)
            if (detection !== undefined)
            {
                this.detection = detection
                this.Trigger(C3.Plugins.Mikal_FaceAPI.Cnds.OnFaceDetectS)
            }
            else
            {
                this.detection = {
                    "error": "NoDetection"
                }
                this.Trigger(C3.Plugins.Mikal_FaceAPI.Cnds.OnFaceDetectSError)
            }
        },

        async FaceDetectSingleLandmarks(uri)
        {
            // input = document.querySelector('canvas')
            let img = await faceapi.fetchImage(uri);
            const detectionWithLandMarks = await faceapi.detectSingleFace(img).withFaceLandmarks()
            if (detectionWithLandMarks !== undefined)
            {
                this.detectionWithLandMarks = detectionWithLandMarks
                this.detection = detectionWithLandMarks
                this.Trigger(C3.Plugins.Mikal_FaceAPI.Cnds.OnFaceDetectS)
            }
            else
            {
                this.detectionWithLandMarks = {
                    "error": "NoDetection"
                }
                this.detection = this.detectionWithLandMarks
                this.Trigger(C3.Plugins.Mikal_FaceAPI.Cnds.OnFaceDetectSE)
            }
        }
    };
}